diff --git a/yum/__init__.py b/yum/__init__.py
index 99039e0..bf13f40 100644
--- a/yum/__init__.py
+++ b/yum/__init__.py
@@ -951,25 +1156,37 @@ class YumBase(depsolve.Depsolve):
             self.repos.populateSack(mdtype='filelists')
            
     def yumUtilsMsg(self, func, prog):
-        """ Output a message that the tool requires the yum-utils package,
-            if not installed. """
+        """Output a message that the given tool requires the yum-utils
+        package, if it not installed.
+
+        :param func: the function to output the message
+        :param prog: the name of the tool that requires yum-utils
+        """
         if self.rpmdb.contains(name="yum-utils"):
             return
 
-        hibeg, hiend = "", ""
-        if hasattr(self, 'term'):
-            hibeg, hiend = self.term.MODE['bold'], self.term.MODE['normal']
-
-        func(_("The program %s%s%s is found in the yum-utils package.") %
-             (hibeg, prog, hiend))
+        func(_("The program %s is found in the yum-utils package.") % self._try_bold(prog))
 
     def buildTransaction(self, unfinished_transactions_check=True):
-        """go through the packages in the transaction set, find them in the
-           packageSack or rpmdb, and pack up the ts accordingly"""
+        """Go through the packages in the transaction set, find them
+        in the packageSack or rpmdb, and pack up the transaction set
+        accordingly.
+
+        :param unfinished_transactions_check: whether to check for
+           unfinished transactions before building the new transaction
+        """
+        # FIXME: This is horrible, see below and yummain. Maybe create a real
+        #        rescode object? :(
+        self._depsolving_failed = False
+
         if (unfinished_transactions_check and
             misc.find_unfinished_transactions(yumlibpath=self.conf.persistdir)):
             msg = _('There are unfinished transactions remaining. You might ' \
-                    'consider running yum-complete-transaction first to finish them.' )
+                    'consider running yum-complete-transaction, or' \
+                    ' "yum-complete-transaction --cleanup-only" and' \
+                    ' "yum history redo last", first to finish them. If those' \
+                    ' don\'t work you\'ll have to try removing/installing' \
+                    ' packages by hand (maybe package-cleanup can help).')
             self.logger.critical(msg)
             self.yumUtilsMsg(self.logger.critical, "yum-complete-transaction")
             time.sleep(3)
@@ -1004,7 +1221,7 @@ class YumBase(depsolve.Depsolve):
             # If transaction was changed by postresolve plugins then we should run skipbroken again
             (rescode, restring) = self._doSkipBroken(rescode, restring, clear_skipped=False )
 
-        if self.tsInfo.pkgSack is not None: # rm Transactions don't have pkgSack
+        if self.tsInfo._pkgSack is not None: # Transactions have pkgSack?
             self.tsInfo.pkgSack.dropCachedData()
 
         # FIXME: This is horrible, see below and yummain. Maybe create a real
@@ -1044,6 +1261,39 @@ class YumBase(depsolve.Depsolve):
                 if first.verEQ(other):
                     continue
                 msg = _('Protected multilib versions: %s != %s')
+                if not xrestring:
+                    #  People are confused about protected mutilib ... so give
+                    # them a nicer message.
+                    bigmsg = _("""\
+ Multilib version problems found. This often means that the root
+cause is something else and multilib version checking is just
+pointing out that there is a problem. Eg.:
+
+  1. You have an upgrade for %(name)s which is missing some
+     dependency that another package requires. Yum is trying to
+     solve this by installing an older version of %(name)s of the
+     different architecture. If you exclude the bad architecture
+     yum will tell you what the root cause is (which package
+     requires what). You can try redoing the upgrade with
+     --exclude %(name)s.otherarch ... this should give you an error
+     message showing the root cause of the problem.
+
+  2. You have multiple architectures of %(name)s installed, but
+     yum can only see an upgrade for one of those architectures.
+     If you don't want/need both architectures anymore then you
+     can remove the one with the missing update and everything
+     will work.
+
+  3. You have duplicate versions of %(name)s installed already.
+     You can use "yum check" to get yum show these errors.
+
+...you can also use --setopt=protected_multilib=false to remove
+this checking, however this is almost never the correct thing to
+do as something else is very likely to go wrong (often causing
+much more problems).
+
+""") % {'name' : pkgname}
+                    msg = bigmsg + msg
                 xrestring.append(msg % (first, other))
         if xrestring:
             rescode = 1
@@ -1227,7 +1477,7 @@ class YumBase(depsolve.Depsolve):
                 self.verbose_logger.info(msg)
             self.skipped_packages.extend(skipped_list)   # make the skipped packages public
         else:
-            # If we cant solve the problems the show the original error messages.
+            # If we can't solve the problems the show the original error messages.
             self.verbose_logger.info("Skip-broken could not solve problems")
             return 1, orig_restring
         return rescode, restring
@@ -1242,13 +1492,15 @@ class YumBase(depsolve.Depsolve):
         if None in pkgtup:
             return None
         return pkgtup
-    def _add_not_found_a(self, pkgs, nevra_dict):
-        pkgtup = self._add_not_found(pkgs, nevra_dict)
+    def _add_not_found_a(self, pkgs, nevra_dict={}, pkgtup=None):
+        if pkgtup is None and nevra_dict:
+            pkgtup = self._add_not_found(pkgs, nevra_dict)
         if pkgtup is None:
             return
         self._not_found_a[pkgtup] = YumNotFoundPackage(pkgtup)
-    def _add_not_found_i(self, pkgs, nevra_dict):
-        pkgtup = self._add_not_found(pkgs, nevra_dict)
+    def _add_not_found_i(self, pkgs, nevra_dict={}, pkgtup=None):
+        if pkgtup is None and nevra_dict:
+            pkgtup = self._add_not_found(pkgs, nevra_dict)
         if pkgtup is None:
             return
         self._not_found_i[pkgtup] = YumNotFoundPackage(pkgtup)
@@ -1267,7 +1519,7 @@ class YumBase(depsolve.Depsolve):
             for pkg in txmbr.obsoleted_by:
                 # check if the obsoleting txmbr is in the transaction
                 # else remove the obsoleted txmbr
-                # it clean out some really wierd cases
+                # it clean out some really weird cases
                 if not self.tsInfo.exists(pkg.pkgtup):
                     self.verbose_logger.debug('SKIPBROKEN: Remove extra obsoleted %s (%s)' % (txmbr.po,pkg) )
                     self.tsInfo.remove(txmbr.po.pkgtup)
@@ -1275,14 +1527,14 @@ class YumBase(depsolve.Depsolve):
     def _checkUpdatedLeftovers(self):
         """ 
         If multiple packages is updated the same package
-        and this package get removed because of an dep issue
+        and this package get removed because of a dep issue
         then make sure that all the TS_UPDATED get removed.
         """
         for txmbr in self.tsInfo.getMembersWithState(None, [TS_UPDATED]):
             for pkg in txmbr.updated_by:
                 # check if the updating txmbr is in the transaction
                 # else remove the updated txmbr
-                # it clean out some really wierd cases with dupes installed on the system
+                # it clean out some really weird cases with dupes installed on the system
                 if not self.tsInfo.exists(pkg.pkgtup):
                     self.verbose_logger.debug('SKIPBROKEN: Remove extra updated %s (%s)' % (txmbr.po,pkg) )
                     self.tsInfo.remove(txmbr.po.pkgtup)
@@ -1379,9 +1631,19 @@ class YumBase(depsolve.Depsolve):
 
     def _getDepsToRemove(self,po, deptree, toRemove):
         for dep in deptree.get(po, []): # Loop trough all deps of po
+            more_deps = False
             for txmbr in self.tsInfo.getMembers(dep.pkgtup):
+                txmbr.removeDep(po)
+                if txmbr.depends_on:
+                    more_deps = True
+                    break
+
                 for pkg in (txmbr.updates + txmbr.obsoletes):
                     toRemove.add(pkg)
+            if more_deps: # Others depend on this pkg, so leave it. bz#905899
+                continue
+            if dep in toRemove: #  If this is true we inf. recurse, so check
+                continue        # even though it shouldn't happen. bz#874065
             toRemove.add(dep)
             self._getDepsToRemove(dep, deptree, toRemove)
 
@@ -1454,7 +1716,46 @@ class YumBase(depsolve.Depsolve):
         return probs
 
     def runTransaction(self, cb):
-        """takes an rpm callback object, performs the transaction"""
+        """Perform the transaction.
+
+        :param cb: an rpm callback object to use in the transaction
+        :return: a :class:`yum.misc.GenericHolder` containing
+           information about the results of the transaction
+        :raises: :class:`yum.Errors.YumRPMTransError` if there is a
+           transaction cannot be completed
+        """
+        if self.fssnap.available and ((self.conf.fssnap_automatic_pre or
+                                       self.conf.fssnap_automatic_post) and
+                                      self.conf.fssnap_automatic_keep):
+            # Automatically kill old snapshots...
+            snaps = self.fssnap.old_snapshots()
+            snaps = sorted(snaps, key=lambda x: (x['ctime'], x['origin_dev']),
+                           reverse=True)
+            last = '<n/a>'
+            num = 0
+            todel = []
+            for snap in snaps:
+                num += 1
+
+                if last != snap['origin_dev']:
+                    last = snap['origin_dev']
+                    num = 1
+                    continue
+
+                if num > self.conf.fssnap_automatic_keep:
+                    todel.append(snap['dev'])
+            # Display something to the user?
+            self.fssnap.del_snapshots(devices=todel)
+
+        if (self.fssnap.available and
+            (not self.ts.isTsFlagSet(rpm.RPMTRANS_FLAG_TEST) and
+            self.conf.fssnap_automatic_pre)):
+            if not self.fssnap.has_space(self.conf.fssnap_percentage):
+                msg = _("Not enough space to create pre. FS snapshot, aborting transaction.")
+                raise Errors.YumRPMTransError(msg=msg, errors=[])
+            else:
+                tags = {'*': ['reason=automatic']} # FIXME: pre. tags
+                self.fssnap.snapshot(self.conf.fssnap_percentage, tags=tags)
 
         self.plugins.run('pretrans')
 
@@ -1516,10 +1817,23 @@ class YumBase(depsolve.Depsolve):
                 pass
         self._ts_save_file = None
         
+        if self.conf.reset_nice:
+            onice = os.nice(0)
+            if onice:
+                try:
+                    os.nice(-onice)
+                except:
+                    onice = 0
+
         errors = self.ts.run(cb.callback, '')
         # ts.run() exit codes are, hmm, "creative": None means all ok, empty 
         # list means some errors happened in the transaction and non-empty 
         # list that there were errors preventing the ts from starting...
+        if self.conf.reset_nice:
+            try:
+                os.nice(onice)
+            except:
+                pass
         
         # make resultobject - just a plain yumgenericholder object
         resultobject = misc.GenericHolder()
@@ -1544,8 +1858,7 @@ class YumBase(depsolve.Depsolve):
                                           errors=errors)
 
                           
-        if (not self.conf.keepcache and
-            not self.ts.isTsFlagSet(rpm.RPMTRANS_FLAG_TEST)):
+        if not self.ts.isTsFlagSet(rpm.RPMTRANS_FLAG_TEST):
             self.cleanUsedHeadersPackages()
         
         for i in ('ts_all_fn', 'ts_done_fn'):
@@ -1567,13 +1880,35 @@ class YumBase(depsolve.Depsolve):
         self.plugins.run('posttrans')
         # sync up what just happened versus what is in the rpmdb
         if not self.ts.isTsFlagSet(rpm.RPMTRANS_FLAG_TEST):
-            self.verifyTransaction(resultobject)
+            vTcb = None
+            if hasattr(cb, 'verify_txmbr'):
+                vTcb = cb.verify_txmbr
+            self.verifyTransaction(resultobject, vTcb)
+            if self.conf.group_command == 'objects':
+                self.igroups.save()
+
+        if (self.fssnap.available and
+            (not self.ts.isTsFlagSet(rpm.RPMTRANS_FLAG_TEST) and
+            self.conf.fssnap_automatic_post)):
+            if not self.fssnap.has_space(self.conf.fssnap_percentage):
+                msg = _("Not enough space to create post trans FS snapshot.")
+                self.logger.critical(msg)
+            else:
+                tags = {'*': ['reason=automatic']} # FIXME: post tags
+                self.fssnap.snapshot(self.conf.fssnap_percentage, tags=tags)
+
         return resultobject
 
-    def verifyTransaction(self, resultobject=None):
-        """checks that the transaction did what we expected it to do. Also 
-           propagates our external yumdb info"""
-        
+    def verifyTransaction(self, resultobject=None, txmbr_cb=None):
+        """Check that the transaction did what was expected, and 
+        propagate external yumdb information.  Output error messages
+        if the transaction did not do what was expected.
+
+        :param resultobject: the :class:`yum.misc.GenericHolder`
+           object returned from the :func:`runTransaction` call that
+           ran the transaction
+        :param txmbr_cb: the callback for the rpm transaction members
+        """
         # check to see that the rpmdb and the tsInfo roughly matches
         # push package object metadata outside of rpmdb into yumdb
         # delete old yumdb metadata entries
@@ -1584,24 +1919,58 @@ class YumBase(depsolve.Depsolve):
         #    that there is not also an install of this pkg in the tsInfo (reinstall)
         # for any kind of install add from_repo to the yumdb, and the cmdline
         # and the install reason
-        
+
+        def _call_txmbr_cb(txmbr, count):
+            if txmbr_cb is not None:
+                count += 1
+                txmbr_cb(txmbr, count)
+            return count
+        
+        oil = self.conf.override_install_langs
+        if not oil:
+            oil = rpm.expandMacro("%_install_langs")
+        if oil == 'all':
+            oil = ''
+        elif oil:
+            oil = ":".join(sorted(oil.split(':')))
         vt_st = time.time()
         self.plugins.run('preverifytrans')
+        count = 0
         for txmbr in self.tsInfo:
             if txmbr.output_state in TS_INSTALL_STATES:
                 if not self.rpmdb.contains(po=txmbr.po):
                     # maybe a file log here, too
                     # but raising an exception is not going to do any good
                     self.logger.critical(_('%s was supposed to be installed' \
-                                           ' but is not!' % txmbr.po))
+                                           ' but is not!') % txmbr.po)
                     # Note: Get Panu to do te.Failed() so we don't have to
                     txmbr.output_state = TS_FAILED
+                    count = _call_txmbr_cb(txmbr, count)
                     continue
+                count = _call_txmbr_cb(txmbr, count)
                 po = self.getInstalledPackageObject(txmbr.pkgtup)
                 rpo = txmbr.po
                 po.yumdb_info.from_repo = rpo.repoid
                 po.yumdb_info.reason = txmbr.reason
                 po.yumdb_info.releasever = self.conf.yumvar['releasever']
+                for var in self.conf.yumvar: # Store all yum variables.
+                    # Skip some of the variables...
+                    if var == 'releasever': continue
+                    if var == 'basearch': continue # This "never" changes.
+                    if var == 'arch':     continue
+                    if var == 'uuid':     continue
+                    setattr(po.yumdb_info, 'var_' + var, self.conf.yumvar[var])
+                if oil:
+                    po.yumdb_info.ts_install_langs = oil
+                if 'nocontexts' in self.conf.tsflags:
+                    po.yumdb_info.tsflag_nocontexts = 'true'
+                if 'nodocs' in self.conf.tsflags:
+                    po.yumdb_info.tsflag_nodocs = 'true'
+                if 'noscripts' in self.conf.tsflags:
+                    po.yumdb_info.tsflag_noscripts = 'true'
+                if 'notriggers' in self.conf.tsflags:
+                    po.yumdb_info.tsflag_notriggers = 'true'
+
                 if hasattr(self, 'args') and self.args:
                     po.yumdb_info.command_line = ' '.join(self.args)
                 elif hasattr(self, 'cmds') and self.cmds:
@@ -1630,6 +1999,10 @@ class YumBase(depsolve.Depsolve):
                     if md:
                         po.yumdb_info.from_repo_timestamp = str(md.timestamp)
 
+                if hasattr(txmbr, 'group_member'):
+                    # FIXME:
+                    po.yumdb_info.group_member = txmbr.group_member
+
                 loginuid = misc.getloginuid()
                 if txmbr.updates or txmbr.downgrades or txmbr.reinstall:
                     if txmbr.updates:
@@ -1640,11 +2013,16 @@ class YumBase(depsolve.Depsolve):
                         opo = po
                     if 'installed_by' in opo.yumdb_info:
                         po.yumdb_info.installed_by = opo.yumdb_info.installed_by
+                    if 'group_member' in opo.yumdb_info:
+                        po.yumdb_info.group_member = opo.yumdb_info.group_member
                     if loginuid is not None:
                         po.yumdb_info.changed_by = str(loginuid)
                 elif loginuid is not None:
                     po.yumdb_info.installed_by = str(loginuid)
 
+                if self.conf.history_record:
+                    self.history.sync_alldb(po)
+
         # Remove old ones after installing new ones, so we can copy values.
         for txmbr in self.tsInfo:
             if txmbr.output_state in TS_INSTALL_STATES:
@@ -1662,10 +2040,13 @@ class YumBase(depsolve.Depsolve):
                                                ' but is not!' % txmbr.po))
                         # Note: Get Panu to do te.Failed() so we don't have to
                         txmbr.output_state = TS_FAILED
+                        count = _call_txmbr_cb(txmbr, count)
                         continue
+                count = _call_txmbr_cb(txmbr, count)
                 yumdb_item = self.rpmdb.yumdb.get_package(po=txmbr.po)
                 yumdb_item.clean()
             else:
+                count = _call_txmbr_cb(txmbr, count)
                 self.verbose_logger.log(logginglevels.DEBUG_2, 'What is this? %s' % txmbr.po)
 
         self.plugins.run('postverifytrans')
@@ -1680,10 +2061,11 @@ class YumBase(depsolve.Depsolve):
         self.verbose_logger.debug('VerifyTransaction time: %0.3f' % (time.time() - vt_st))
 
     def costExcludePackages(self):
-        """ Create an excluder for repos. with higher cost. Eg.
-            repo-A:cost=1 repo-B:cost=2 ... here we setup an excluder on repo-B
-            that looks for pkgs in repo-B."""
-        
+        """Create an excluder for repositories with higher costs. For
+        example, if repo-A:cost=1 and repo-B:cost=2, this function
+        will set up an excluder on repo-B that looks for packages in
+        repo-B.
+        """
         # if all the repo.costs are equal then don't bother running things
         costs = {}
         for r in self.repos.listEnabled():
@@ -1705,10 +2087,12 @@ class YumBase(depsolve.Depsolve):
             done = True
 
     def excludePackages(self, repo=None):
-        """removes packages from packageSacks based on global exclude lists,
-           command line excludes and per-repository excludes, takes optional 
-           repo object to use."""
+        """Remove packages from packageSacks based on global exclude
+        lists, command line excludes and per-repository excludes.
 
+        :param repo: a repo object to use.  If not given, all
+           repositories are used
+        """
         if "all" in self.conf.disable_excludes:
             return
         
@@ -1735,9 +2119,14 @@ class YumBase(depsolve.Depsolve):
             self.pkgSack.addPackageExcluder(repoid, exid,'exclude.match', match)
 
     def includePackages(self, repo):
-        """removes packages from packageSacks based on list of packages, to include.
-           takes repoid as a mandatory argument."""
-        
+        """Remove packages from packageSacks based on list of
+        packages to include.  
+
+        :param repo: the repository to use
+        """
+        for di in getattr(self.conf, 'disable_includes', []):
+            if di == 'all' or di == repo.id:
+                return
         includelist = repo.getIncludePkgList()
         
         if len(includelist) == 0:
@@ -1757,8 +2146,11 @@ class YumBase(depsolve.Depsolve):
         self.pkgSack.addPackageExcluder(repo.id, exid, 'exclude.marked')
         
     def doLock(self, lockfile = YUM_PID_FILE):
-        """perform the yum locking, raise yum-based exceptions, not OSErrors"""
-        
+        """Acquire the yum lock.
+
+        :param lockfile: the file to use for the lock
+        :raises: :class:`yum.Errors.LockError`
+        """
         if self.conf.uid != 0:
             #  If we are a user, assume we are using the root cache ... so don't
             # bother locking.
@@ -1773,39 +2165,39 @@ class YumBase(depsolve.Depsolve):
         lockfile = os.path.normpath(lockfile) # get rid of silly preceding extra /
         
         mypid=str(os.getpid())    
-        while not self._lock(lockfile, mypid, 0644):
-            try:
-                fd = open(lockfile, 'r')
-            except (IOError, OSError), e:
-                msg = _("Could not open lock %s: %s") % (lockfile, e)
-                raise Errors.LockError(errno.EPERM, msg)
-                
-            try: oldpid = int(fd.readline())
-            except ValueError:
-                # bogus data in the pid file. Throw away.
+        while True:
+            ret = self._lock(lockfile, mypid, 0644)
+            if ret:
+                break
+
+            oldpid = self._get_locker(lockfile)
+            if not oldpid:
+                # Invalid locker: unlink lockfile and retry
                 self._unlock(lockfile)
-            else:
-                if oldpid == os.getpid(): # if we own the lock, we're fine
-                    break
-                try: os.kill(oldpid, 0)
-                except OSError, e:
-                    if e[0] == errno.ESRCH:
-                        # The pid doesn't exist
-                        self._unlock(lockfile)
-                    else:
-                        # Whoa. What the heck happened?
-                        msg = _('Unable to check if PID %s is active') % oldpid
-                        raise Errors.LockError(errno.EPERM, msg, oldpid)
-                else:
-                    # Another copy seems to be running.
-                    msg = _('Existing lock %s: another copy is running as pid %s.') % (lockfile, oldpid)
-                    raise Errors.LockError(0, msg, oldpid)
+                continue
+            if oldpid == os.getpid(): # if we own the lock, we're fine
+                ret = 1
+                break
+            # Another copy seems to be running.
+            msg = _('Existing lock %s: another copy is running as pid %s.') % (lockfile, oldpid)
+            raise Errors.LockError(0, msg, oldpid)
+
+        if ret == 2:
+            #  Means lockdir isn't setup, out of bad options just run without
+            # locks.
+            return
+
+        assert ret == 1
         # We've got the lock, store it so we can auto-unlock on __del__...
         self._lockfile = lockfile
     
     def doUnlock(self, lockfile=None):
-        """do the unlock for yum"""
-        
+        """Release the yum lock.
+
+        :param lockfile: the lock file to use.  If not given, the file
+           that was given as a parameter to the :func:`doLock` call
+           that closed the lock is used
+        """
         # if we're not root then we don't lock - just return nicely
         #  Note that we can get here from __del__, so if we haven't created
         # YumBase.conf we don't want to do so here as creating stuff inside
@@ -1830,31 +2222,74 @@ class YumBase(depsolve.Depsolve):
         self._unlock(lockfile)
         self._lockfile = None
         
-    def _lock(self, filename, contents='', mode=0777):
+    @staticmethod
+    def _lock(filename, contents='', mode=0777):
         lockdir = os.path.dirname(filename)
         try:
             if not os.path.exists(lockdir):
-                os.makedirs(lockdir, mode=0755)
+                #  We used to os.makedirs(lockdir, mode=0755) ... but that
+                # causes problems now due to /var/run being a magic systemd dir.
+                #  So we now just give up and run, hopefully nobody runs N
+                # instances before the magic dir. is activate.
+                return 2
+
             fd = os.open(filename, os.O_EXCL|os.O_CREAT|os.O_WRONLY, mode)    
+            os.write(fd, contents)
+            os.close(fd)
+            return 1
         except OSError, msg:
             if not msg.errno == errno.EEXIST: 
                 # Whoa. What the heck happened?
-                errmsg = _('Could not create lock at %s: %s ') % (filename, str(msg))
+                errmsg = _('Could not create lock at %s: %s ') % (filename, exception2msg(msg))
                 raise Errors.LockError(msg.errno, errmsg, int(contents))
             return 0
-        else:
-            os.write(fd, contents)
-            os.close(fd)
-            return 1
     
-    def _unlock(self, filename):
+    @staticmethod
+    def _unlock(filename):
         misc.unlink_f(filename)
 
+    @staticmethod
+    def _get_locker(lockfile):
+        try: fd = open(lockfile, 'r')
+        except (IOError, OSError), e:
+            msg = _("Could not open lock %s: %s") % (lockfile, e)
+            raise Errors.LockError(errno.EPERM, msg)
+        try: oldpid = int(fd.readline())
+        except ValueError:
+            return None # Bogus pid
+
+        try:
+            stat = open("/proc/%d/stat" % oldpid).readline()
+            if stat.split()[2] == 'Z':
+                return None # The pid is a zombie
+        except IOError:
+            # process dead or /proc not mounted
+            try: os.kill(oldpid, 0)
+            except OSError, e:
+                if e[0] == errno.ESRCH:
+                    return None # The pid doesn't exist
+                # Whoa. What the heck happened?
+                msg = _('Unable to check if PID %s is active') % oldpid
+                raise Errors.LockError(errno.EPERM, msg, oldpid)
+        return oldpid
+
     def verifyPkg(self, fo, po, raiseError):
-        """verifies the package is what we expect it to be
-           raiseError  = defaults to 0 - if 1 then will raise
-           a URLGrabError if the file does not check out.
-           otherwise it returns false for a failure, true for success"""
+        """Check that the checksum of a remote package matches what we
+        expect it to be.  If the checksum of the package file is
+        wrong, and the file is also larger than expected, it cannot be
+        redeemed, so delete it.
+
+        :param fo: the file object of the package
+        :param po: the package object to verify
+        :param raiseError: if *raiseError* is 1, and the package
+           does not check out, a :class:`URLGrabError will be raised.
+           Defaults to 0
+        :return: True if the package is verified successfully.
+           Otherwise, False will be returned, unless *raiseError* is
+           1, in which case a :class:`URLGrabError` will be raised
+        :raises: :class:`URLGrabError` if verification fails, and
+           *raiseError* is 1
+        """
         failed = False
 
         if type(fo) is types.InstanceType:
@@ -1877,10 +2312,10 @@ class YumBase(depsolve.Depsolve):
             cursize = os.stat(fo)[6]
             totsize = long(po.size)
             if cursize >= totsize and not po.repo.cache:
-                # if the path to the file is NOT inside the cachedir then don't
-                # unlink it b/c it is probably a file:// url and possibly
+                # if the path to the file is NOT inside the pkgdir then don't
+                # unlink it b/c it is probably a file:// url and possibly not
                 # unlinkable
-                if fo.startswith(po.repo.cachedir):
+                if fo.startswith(po.repo.pkgdir):
                     os.unlink(fo)
 
             if raiseError:
@@ -1894,9 +2329,16 @@ class YumBase(depsolve.Depsolve):
         
         
     def verifyChecksum(self, fo, checksumType, csum):
-        """Verify the checksum of the file versus the 
-           provided checksum"""
-
+        """Verify that the checksum of the given file matches the
+        given checksum.
+
+        :param fo: the file object to verify the checksum of
+        :param checksumType: the type of checksum to use
+        :parm csum: the checksum to check against
+        :return: 0 if the checksums match
+        :raises: :class:`URLGrabError` if there is an error performing
+           the checksums, or the checksums do not match
+        """
         try:
             filesum = misc.checksum(checksumType, fo)
         except Errors.MiscError, e:
@@ -1908,13 +2350,26 @@ class YumBase(depsolve.Depsolve):
         return 0
 
     def downloadPkgs(self, pkglist, callback=None, callback_total=None):
+        """Download the packages specified by the given list of
+        package objects.
+
+        :param pkglist: a list of package objects specifying the
+           packages to download
+        :param callback: unused
+        :param callback_total: a callback to output messages about the
+           download operation
+        :return: a dictionary containing errors from the downloading process
+        :raises: :class:`URLGrabError`
+        """
         def mediasort(apo, bpo):
             # FIXME: we should probably also use the mediaid; else we
             # could conceivably ping-pong between different disc1's
             a = apo.getDiscNum()
             b = bpo.getDiscNum()
             if a is None and b is None:
-                return cmp(apo, bpo)
+                # deltas first to start rebuilding asap
+                return cmp(isinstance(bpo, DeltaPackage),
+                           isinstance(apo, DeltaPackage)) or cmp(apo, bpo)
             if a is None:
                 return -1
             if b is None:
@@ -1925,12 +2380,11 @@ class YumBase(depsolve.Depsolve):
                 return 1
             return 0
         
-        """download list of package objects handed to you, output based on
-           callback, raise yum.Errors.YumBaseError on problems"""
-
         errors = {}
         def adderror(po, msg):
             errors.setdefault(po, []).append(msg)
+            if po.localpath.endswith('.tmp'):
+                misc.unlink_f(po.localpath) # won't resume this..
 
         #  We close the history DB here because some plugins (presto) use
         # threads. And sqlite really doesn't like threads. And while I don't
